﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Globalization;

namespace Business.Classes
{
    public class DateTimeBusiness
    {
        public string ConvertToShamsi(string date, int hour = 0, int minute = 0, int second = 0)
        {
            System.Globalization.PersianCalendar pc = new System.Globalization.PersianCalendar();
            DateTime dt = DateTime.Parse(date);
            int year = pc.GetYear(dt);
            int month = pc.GetMonth(dt);
            int day = pc.GetDayOfMonth(dt);
            return year.ToString() + "/" + (month < 10 ? "0" : "") + month.ToString() + "/" + (day < 10 ? "0" : "") + day.ToString();
        }

        public DateTime ConvertToMilady(string date, int hour = 0, int minute = 0, int second = 0, int miliSecond = 0)
        {
            string[] dateTemp = date.Split('/');
            PersianCalendar pc = new PersianCalendar();
            DateTime dateMilady = new DateTime();
            try
            {
                dateMilady = pc.ToDateTime(int.Parse(dateTemp[0]), int.Parse(dateTemp[1]), int.Parse(dateTemp[2]), hour, minute, second, miliSecond);
            }
            catch
            {

            }

            return dateMilady;
        }

        public string GetMonthPersian(string tmp)
        {
            switch (tmp)
            {
                case "1":
                    {
                        return "فروردین";
                    }

                case "2":
                    {
                        return "اردیبهشت";
                    }

                case "3":
                    {
                        return "خرداد";
                    }

                case "4":
                    {
                        return "تیر";
                    }
                case "5":
                    {
                        return "مرداد";
                    }
                case "6":
                    {
                        return "شهریور";
                    }
                case "7":
                    {
                        return "مهر";
                    }
                case "8":
                    {
                        return "آبان";
                    }
                case "9":
                    {
                        return "آذر";
                    }
                case "10":
                    {
                        return "دی";
                    }
                case "11":
                    {
                        return "بهمن";
                    }
                case "12":
                    {
                        return "اسفند";
                    }
            }

            return "";
        }

        public string GetNumberMonthPersian(string tmp)
        {
            switch (tmp)
            {
                case "فروردین":
                    {
                        return "1";
                    }

                case "اردیبهشت":
                    {
                        return "2";
                    }

                case "خرداد":
                    {
                        return "3";
                    }

                case "تیر":
                    {
                        return "4";
                    }
                case "مرداد":
                    {
                        return "5";
                    }
                case "شهریور":
                    {
                        return "6";
                    }
                case "مهر":
                    {
                        return "7";
                    }
                case "آبان":
                    {
                        return "8";
                    }
                case "آذر":
                    {
                        return "9";
                    }
                case "دی":
                    {
                        return "10";
                    }
                case "بهمن":
                    {
                        return "11";
                    }
                case "اسفند":
                    {
                        return "12";
                    }
            }

            return "-1";
        }
    }
}