﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using Persist.Services;
using System.Collections;

namespace Business.Controller
{
    public class PageController
    {
        PageServices PageServices;
        AccessController AccessController;

        public PageController()
        {
            this.PageServices = new PageServices();
            this.AccessController = new AccessController();
        }

        public bool Create(Page page)
        {
            bool status = false;

            try
            {
                PageServices.Create(page);
                status = true;
            }
            catch
            {
            }

            return status;
        }

        public bool Update(Page page)
        {
            bool status = false;

            try
            {
                Page result = Find(page.PageID);

                if (result != null)
                {
                    PageServices.Update(page);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }

        public bool Delete(int pageID)
        {
            bool status = false;

            try
            {
                status = DeleteAccesses(pageID);

                if (!status)
                    throw new Exception();

                status = false;
                PageServices.RefreshContext();

                Page result = Find(pageID);

                if (result != null)
                {
                    PageServices.Delete(pageID);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }


        public bool DeleteAccesses(int pageID)
        {
            bool status = true;

            try
            {
                foreach (Access item in PageServices.GetAccesses(pageID))
                {
                    status = AccessController.Delete(item.AccessID);
                    if (!status)
                        break;
                }
            }
            catch
            {
                status = false;
            }

            return status;
        }

        public Page Find(int pageID)
        {
            Page result = null;

            try
            {
                result = PageServices.Find(pageID);
            }
            catch
            {
            }

            return result;
        }

        public List<Page> FindAll()
        {
            List<Page> results = null;

            try
            {
                results = PageServices.FindAll();
            }
            catch
            {
            }

            return results;
        }


        public List<Access> GetAccesses(int pageID)
        {
            List<Access> results = null;

            try
            {
                results = PageServices.GetAccesses(pageID);
            }
            catch
            {
            }

            return results;
        }
    }
}