﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using Persist.Services;
using System.Collections;

namespace Business.Controller
{
    public class UserTypeController
    {
        UserTypeServices UserTypeServices;
        PersonController PersonController;
        AccessController AccessController;

        public UserTypeController()
        {
            this.UserTypeServices = new UserTypeServices();
            this.PersonController = new PersonController();
            this.AccessController = new AccessController();
        }

        public bool Create(UserType userType)
        {
            bool status = false;

            try
            {
                UserTypeServices.Create(userType);
                status = true;
            }
            catch
            {
            }

            return status;
        }

        public bool Update(UserType userType)
        {
            bool status = false;

            try
            {
                UserType result = Find(userType.UserTypeID);

                if (result != null)
                {
                    UserTypeServices.Update(userType);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }

        public bool Delete(int userTypeID)
        {
            bool status = false;

            try
            {
                status = DeletePeople(userTypeID);

                if (!status)
                    throw new Exception();

                status = false;
                UserTypeServices.RefreshContext();

                status = DeleteAccesses(userTypeID);

                if (!status)
                    throw new Exception();

                status = false;
                UserTypeServices.RefreshContext();

                UserType result = Find(userTypeID);

                if (result != null)
                {
                    UserTypeServices.Delete(userTypeID);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }


        public bool DeletePeople(int userTypeID)
        {
            bool status = true;

            try
            {
                foreach (Person item in UserTypeServices.GetPeople(userTypeID))
                {
                    status = PersonController.Delete(item.PersonID);
                    if (!status)
                        break;
                }
            }
            catch
            {
                status = false;
            }

            return status;
        }

        public bool DeleteAccesses(int userTypeID)
        {
            bool status = true;

            try
            {
                foreach (Access item in UserTypeServices.GetAccesses(userTypeID))
                {
                    status = AccessController.Delete(item.AccessID);
                    if (!status)
                        break;
                }
            }
            catch
            {
                status = false;
            }

            return status;
        }

        public UserType Find(int userTypeID)
        {
            UserType result = null;

            try
            {
                result = UserTypeServices.Find(userTypeID);
            }
            catch
            {
            }

            return result;
        }

        public List<UserType> FindAll()
        {
            List<UserType> results = null;

            try
            {
                results = UserTypeServices.FindAll();
            }
            catch
            {
            }

            return results;
        }


        public List<Person> GetPeople(int userTypeID)
        {
            List<Person> results = null;

            try
            {
                results = UserTypeServices.GetPeople(userTypeID);
            }
            catch
            {
            }

            return results;
        }

        public List<Access> GetAccesses(int userTypeID)
        {
            List<Access> results = null;

            try
            {
                results = UserTypeServices.GetAccesses(userTypeID);
            }
            catch
            {
            }

            return results;
        }
    }
}