﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using System.Collections;

namespace Persist.Services
{
    public class HotelServices
    {
        HotelSiteEntities Context;

        public HotelServices()
        {
            this.Context = new HotelSiteEntities();
        }

        public void Create(Hotel hotel)
        {
            Context.Hotels.AddObject(hotel);
            Context.SaveChanges();
        }

        public void Update(Hotel hotel)
        {
            Hotel result = Find(hotel.HotelID);

            result.Description = hotel.Description;
            result.Image = hotel.Image;
            result.Address = hotel.Address;
            result.HotelName = hotel.HotelName;
            result.Email = hotel.Email;
            result.Telephone = hotel.Telephone;

            Context.SaveChanges();
        }

        public void Delete(int hotelID)
        {
            Hotel result = Find(hotelID);

            Context.Hotels.DeleteObject(result);
            Context.SaveChanges();
        }

        public Hotel Find(int hotelID)
        {
            Hotel result = Context.Hotels.Where(r => r.HotelID == hotelID).SingleOrDefault();
            return result;
        }

        public List<Hotel> FindAll()
        {
            List<Hotel> results = Context.Hotels.Select(r => r).ToList();
            return results;
        }
        public void RefreshContext()
        {
            Context = new HotelSiteEntities();
        }
    }
}