﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using System.Collections;

namespace Persist.Services
{
    public class PageServices
    {
        HotelSiteEntities Context;

        public PageServices()
        {
            this.Context = new HotelSiteEntities();
        }

        public void Create(Page page)
        {
            Context.Pages.AddObject(page);
            Context.SaveChanges();
        }

        public void Update(Page page)
        {
            Page result = Find(page.PageID);

            result.PageName = page.PageName;

            Context.SaveChanges();
        }

        public void Delete(int pageID)
        {
            Page result = Find(pageID);

            Context.Pages.DeleteObject(result);
            Context.SaveChanges();
        }

        public Page Find(int pageID)
        {
            Page result = Context.Pages.Where(r => r.PageID == pageID).SingleOrDefault();
            return result;
        }

        public List<Page> FindAll()
        {
            List<Page> results = Context.Pages.Select(r => r).ToList();
            return results;
        }


        public List<Access> GetAccesses(int page_ID)
        {
            List<Access> results = Context.Accesses.Where(r => r.Page_ID == page_ID).ToList();
            return results;
        }
        public void RefreshContext()
        {
            Context = new HotelSiteEntities();
        }
    }
}